macroScript WorldLocalPinner
category:"KFScripts" 
toolTip:"World Local Pinner 1.00" 
buttonText:"World Local Pinner 1.00"
------------------------------------
----v1.00 of World Local Pinner-----
-------Written by Kiel Figgins------
---------www.3dfiggins.com----------
------------------------------------
--Automated interface for Creating a World Local Pinning for Controls
--------------------
--Version History
--------------------
-----
--1.00 (10-11-2006) - Original Script
--------------------
--Coming Soon
--------------------
--

(
try(destroydialog headLocker)catch()
rollout headLocker "World Local Pinner                       v1.00" 
(
	label lblHead "1. Select (1) Pinned Control, then" pos:[3,3] width:160 height:14
	label lblChest "2. Select (1) Base Control, then" pos:[3,33] width:160 height:14
	label lblWorld "3. Select (1) World Control, then" pos:[3,62] width:160 height:14
	label lblHeadDefine "- -   - -" pos:[35,18] width:141 height:12
	label lblChestDefine "- -   - -" pos:[35,48] width:141 height:12
	label lblWorldDefine "- -   - -" pos:[35,78] width:141 height:12

	button btnHead "Click Here" pos:[165,3] width:53 height:15
	button btnChest "Click Here" pos:[165,32] width:53 height:15
	button btnWorld "Click Here" pos:[165,62] width:53 height:15
	
	editText edtCust "4. Custom Naming" text:"Head" pos:[3,90] width:215 height:17
	
	button btnCreate "Create World/Local" pos:[65,112] width:102 height:25
	button btnHelp "?" pos:[205,123] width:14 height:14
	

-----------------------
--Variables
-----------------------
global userHead
global userChest
global userWorld

-----------------------
--Functions
-----------------------
fn KFFreeze = 	
	( 		
		local Obj = Selection as array 		
		for i = 1 to Obj.count do 		
		( 
			Try
			(	
				local CurObj = Obj[i] 	
	
				-- freeze rotation		
				CurObj.rotation.controller = Euler_Xyz() 		
				CurObj.rotation.controller = Rotation_list() 			
				CurObj.rotation.controller.available.controller = Euler_xyz() 		
				
				/* "Localization on" */  
			
				CurObj.rotation.controller.setname 1 "Initial Pose" 		
				CurObj.rotation.controller.setname 2 "Keyframe XYZ" 		
			
				/* "Localization off" */  
				
				CurObj.rotation.controller.SetActive 2 		
	
				-- freeze position
				CurObj.position.controller = Bezier_Position() 			
				CurObj.position.controller = position_list() 			
				CurObj.position.controller.available.controller = Position_XYZ() 	
	
				/* "Localization on" */  
						
				CurObj.position.controller.setname 1 "Frozen Position" 	
				CurObj.position.controller.setname 2 "Zero Pos XYZ" 			
				
				/* "Localization off" */  
				
				CurObj.position.controller.SetActive 2 		
	
				-- position to zero
				CurObj.Position.controller[2].x_Position = 0
				CurObj.Position.controller[2].y_Position = 0
				CurObj.Position.controller[2].z_Position = 0
			)	
			/* "Localization on" */  
					
			Catch( messagebox "A failure occurred while freezing an object's transform." title:"Freeze Transform")
					
			/* "Localization off" */  	
		)
		select Obj

	)

--To run just add:
--   KFFreeze()
-------------- End of Functions

on btnHead pressed do
(
	rightSel = selection.count

	if rightSel == 1 then
		(
			userHead = $
			lblHeadDefine.text = $.name
		)
		else
		(
			print "Please select only 1 (one) object"
			lblHeadDefine.text = "- -   - -"
		)
	
)--End of btnHead
---------------------------------------------------------
---------------------------------------------------------

on btnChest pressed do
(
	rightSel = selection.count

	if rightSel == 1 then
		(
			userChest = $
			lblChestDefine.text = $.name
		)
		else
		(
			print "Please select only 1 (one) object"
			lblChestDefine.text = "- -   - -"
		)
	
)--End of btnChest
---------------------------------------------------------
---------------------------------------------------------

on btnWorld pressed do
(
	rightSel = selection.count

	if rightSel == 1 then
		(
			userWorld = $
			lblWorldDefine.text = $.name
		)
		else
		(
			print "Please select only 1 (one) object"
			lblWorldDefine.text = "- -   - -"
		)
		
)--End of btnWorld
---------------------------------------------------------
---------------------------------------------------------

on btnCreate pressed do
(
--Verify that something is selected for each control
--Adjust time line before setting wires

headVer = 0
chestVer = 0
worldVer = 0

--Verification
try(
select userHead
headVer = 1
) catch(print "No Pinned Object selected")

try(
select userChest
chestVer = 1
) catch(print "No Base Object selected")

try(
select userWorld
worldVer = 1
) catch(print "No World Object selected")

verified = headVer + chestVer + worldVer as integer

if verified == 3 then
(	
	custName = edtCust.text as string
	
	--For Base
	baseName = "rig_" + custName + "locktarget" as string 
	Point pos:[0,0,0] name:baseName size:5 isSelected:on cross:off Box:on centermarker:off axisTripod:off wirecolor: (color 14 255 2)
	headLockTarget = $
	headLockTarget.pos = userChest.pos
	headLockTarget.parent = userChest
	clearSelection()
	
	--For Pinned
	pinnedName = "rig_" + custName + "Const" as string 
	Point pos:[0,0,0] name:pinnedName size:5 isSelected:on cross:off Box:on centermarker:off axisTripod:off wirecolor: (color 14 255 2)
	headConst = $
	headConst.pos = userHead.pos
	userHead.parent = headConst
	headConst.parent = userChest
	clearSelection()
	
	--Freeze rig_HeadConst
	select headConst
	KFFreeze()
	clearSelection()
	
	--Add orient constraint
	headConst.rotation.controller.Available.controller = Orientation_Constraint ()
	headConst.rotation.controller.Orientation_Constraint.controller.relative = on
	
	--set active to 3rd
	headConst.rotation.controller.SetActive 3
	
	--Add headlocktarget, ctrl_world 
	headConst.rotation.controller.Orientation_Constraint.controller.appendTarget headLockTarget 0.0
	headConst.rotation.controller.Orientation_Constraint.controller.appendTarget userWorld 0.0
	
	headConst.rotation.controller.Orientation_Constraint.controller.weight[1] = 0
	headConst.rotation.controller.Orientation_Constraint.controller.weight[2] = 10
	
	--Script to connect it all up
	setCommandPanelTaskMode #modify
	addModifier userHead(EmptyModifier ()) ui:on 
	userHead.Attribute_Holder.name = "Pinner_Lock"
	select userHead
	
	PinnerLock_Attr = attributes PinnerLock
	(
		parameters main rollout: PinnerLock 
		(
			PinnerLocker type:#float UI:PinnerLocker default:0.0
		)
		rollout PinnerLock "Pinning" 
		(
			slider PinnerLocker "Pinning World Local" ticks:10 range:[0,10,0]
		)--End of Rollout
	
	)
	custAttributes.add (modPanel.getCurrentObject() ) PinnerLock_Attr #unique
	
	------------------------------
	--connecting up the Blend
	------------------------------
	
	--Adjusting timeslider for better WireParrameter Connections
	timeStart = (animationRange.start as integer)/TicksPerFrame
	timeEnd = (animationRange.end as integer)/TicksPerFrame
	
	animationRange = interval 0 1000
	
	paramWire.connect userHead.modifiers[#Pinner_Lock].PinnerLock[#PinnerLocker] headConst.rotation.controller.Orientation_Constraint.controller[#Orientation_Weight_0] "PinnerLocker"
	paramWire.connect userHead.modifiers[#Pinner_Lock].PinnerLock[#PinnerLocker] headConst.rotation.controller.Orientation_Constraint.controller[#Orientation_Weight_1] "-(PinnerLocker) + 10"
	
	animationRange = interval timeStart timeEnd
	
	clearSelection()
	
	lblHeadDefine.text = "- -   - -"
	lblChestDefine.text = "- -   - -"
	lblWorldDefine.text = "- -   - -"
)
else
(print "Missing an Object, Pinning Cancelled")

)--End of btnCreate

---------------------------------------------------------
---------------------------------------------------------
on btnHelp pressed do
(
	rollout helpWin "About World Local"
		(
			label lbl001 "World Local is used for creating a controllable blend" align:#Left
			label lbl002 "from World space to Local space." align:#Left
			label lbl003 "This can be helpful on such controls like:" align:#Left
			label lbl004 "Head, Tail Base, Tongue Base, ect" align:#Left
			label lbl005 ""
			label lbl006 "To use:" align:#Left
			label lbl007 "-Select the controller you want the pinning to go on" align:#Left
			label lbl008 "-Select the controller that it will be pinned to" align:#Left
			label lbl009 "-Select the controller that will offset the pinning" align:#Left
			label lbl010 ""
			label lbl011 "An example of this would be:" align:#Left
			label lbl012 "Pinned = Head, Base = Chest, World = Master" align:#Left
			label lbl013 "This example would give you the ability to have the" align:#Left
			label lbl014 "Head rotate with the chest or independant of it." align:#Left
			label lbl015 ""
			label lbl016 "Use the Custom Naming to prevent erroring or unneeded" align:#Left
			label lbl017 "duplication of nodes in your scene." align:#Left
		)--End of helpWin Rollout
	createDialog helpWin width:295

)--End of btnHelp

---------------------------------------------------------
---------------------------------------------------------

)--End of Rollout
createDialog headLocker width:225 height:140 pos:[1078,80] \
style:#(#style_border, #style_titlebar, #style_sysmenu, #style_minimizebox)
try(cui.RegisterDialogBar headLocker maxsize:[225,140]) catch()

)--End of Script